Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.functions
Class FunctionLibraryList

    java.lang.Object
      net.sf.saxon.functions.FunctionLibraryList

All Implemented Interfaces:
  FunctionLibrary, java.io.Serializable, XQueryFunctionBinder

public class FunctionLibraryList
extends java.lang.Object
implements FunctionLibrary, XQueryFunctionBinder

A FunctionLibraryList is a list of FunctionLibraries. It is also a FunctionLibrary in its own right. When required, it searches the list of FunctionLibraries to find the required function.

See Also:
  Serialized Form

Field Summary
`java.util.List` | `libraryList`

Constructor Summary
`FunctionLibraryList()`

Method Summary
`int` | `addFunctionLibrary(FunctionLibrary lib)` Add a new FunctionLibrary to the list of FunctionLibraries in this FunctionLibraryList.
`Expression` | `bind(int nameCode, java.lang.String uri, java.lang.String local, Expression[] staticArgs)` Bind an extension function, given the URI and local parts of the function name, and the list of expressions supplied as arguments.
`FunctionLibrary` | `copy()` This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
`FunctionLibrary` | `get(int n)` Get the n'th function library in the list
`XQueryFunction` | `getDeclaration(int nameCode, java.lang.String uri, java.lang.String local, Expression[] staticArgs)` Get the function declaration corresponding to a given function name and arity
`java.util.List` | `getLibraryList()` Get the list of contained FunctionLibraries.
`boolean` | `isAvailable(int fingerprint, java.lang.String uri, java.lang.String local, int arity)` Test whether an extension function with a given name and arity is available.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### libraryList

    public java.util.List libraryList

Constructor Detail

### FunctionLibraryList

    public FunctionLibraryList()

Method Detail

### addFunctionLibrary

    public int addFunctionLibrary(FunctionLibrary lib)

  Add a new FunctionLibrary to the list of FunctionLibraries in this FunctionLibraryList. Note that libraries are searched in the order they are added to the list.

  Parameters:
    `lib` - A function library to be added to the list of function libraries to be searched.
  Returns:
    the position of the library in the list

### get

    public FunctionLibrary get(int n)

  Get the n'th function library in the list

### isAvailable

    public boolean isAvailable(int fingerprint,
                               java.lang.String uri,
                               java.lang.String local,
                               int arity)

  Test whether an extension function with a given name and arity is available. This supports the function-available() function in XSLT. This method may be called either at compile time or at run time.

  Specified by:
    `isAvailable` in interface `FunctionLibrary`
  Parameters:
    `uri` - The URI of the function name
    `local` - The local part of the function name
    `arity` - The number of arguments. This is set to -1 in the case of the single-argument function-available() function; in this case the method should return true if there is some matching extension function, regardless of its arity.
    `fingerprint` - The namepool fingerprint of the function name. This must match the uri and localName; the information is provided redundantly to avoid repeated lookups in the name pool.

### bind

    public Expression bind(int nameCode,
                           java.lang.String uri,
                           java.lang.String local,
                           Expression[] staticArgs)
                    throws XPathException

  Bind an extension function, given the URI and local parts of the function name, and the list of expressions supplied as arguments. This method is called at compile time.

  Specified by:
    `bind` in interface `FunctionLibrary`
  Parameters:
    `uri` - The URI of the function name
    `local` - The local part of the function name
    `staticArgs` - The expressions supplied statically in arguments to the function call. The length of this array represents the arity of the function. The intention is that the static type of the arguments (obtainable via getItemType() and getCardinality() may be used as part of the binding algorithm. In some cases it may be possible for the function to be pre-evaluated at compile time, for example if these expressions are all constant values.
    `nameCode` - The namepool nameCode of the function name. The uri and local name are also supplied (redundantly) to avoid fetching them from the name pool.
  Returns:
    An object representing the extension function to be called, if one is found; null if no extension function was found matching the required name and arity.
  Throws:
    `XPathException` - if a function is found with the required name and arity, but the implementation of the function cannot be loaded or used; or if an error occurs while searching for the function.

### getDeclaration

    public XQueryFunction getDeclaration(int nameCode,
                                         java.lang.String uri,
                                         java.lang.String local,
                                         Expression[] staticArgs)

  Get the function declaration corresponding to a given function name and arity

  Specified by:
    `getDeclaration` in interface `XQueryFunctionBinder`
  Returns:
    the XQueryFunction if there is one, or null if not.

### getLibraryList

    public java.util.List getLibraryList()

  Get the list of contained FunctionLibraries. This method allows the caller to modify the library list, for example by adding a new FunctionLibrary at a chosen position, by removing a library from the list, or by changing the order of libraries in the list. Note that such changes may violate rules in the language specifications, or assumptions made within the product.

  Returns:
    a list whose members are of class FunctionLibrary

### copy

    public FunctionLibrary copy()

  This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.

  Specified by:
    `copy` in interface `FunctionLibrary`
  Returns:
    a copy of this function library. This must be an instance of the original class.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD